## bowtie 1.0.0

=== Makefile ===
#
# Makefile for bowtie, bowtie-build, bowtie-inspect
#

SEQAN_DIR = SeqAn-1.1
SEQAN_INC = -I $(SEQAN_DIR)
INC = $(SEQAN_INC)
CPP = g++
CXX = $(CPP)
CC = gcc
HEADERS = $(wildcard *.h)
BOWTIE_MM = 1
BOWTIE_SHARED_MEM = 1
EXTRA_FLAGS =
EXTRA_CFLAGS =
EXTRA_CXXFLAGS =
CFLAGS += $(EXTRA_CFLAGS)
CXXFLAGS += $(EXTRA_CXXFLAGS)

# Detect Cygwin or MinGW
WINDOWS = 0
CYGWIN = 0
MINGW = 0
ifneq (,$(findstring CYGWIN,$(shell uname)))
    WINDOWS = 1
    CYGWIN = 1
    # POSIX memory-mapped files not currently supported on Windows
    BOWTIE_MM = 0
    BOWTIE_SHARED_MEM = 0
else
    ifneq (,$(findstring MINGW,$(shell uname)))
	WINDOWS = 1
	MINGW = 1
	# POSIX memory-mapped files not currently supported on Windows
	BOWTIE_MM = 0
	BOWTIE_SHARED_MEM = 0
    endif
endif

MACOS = 0
ifneq (,$(findstring Darwin,$(shell uname)))
    MACOS = 1
endif

LINUX = 0
ifneq (,$(findstring Linux,$(shell uname)))
    LINUX = 1
    EXTRA_FLAGS += -Wl,--hash-style=both
endif

MM_DEF = 
ifeq (1,$(BOWTIE_MM))
    MM_DEF = -DBOWTIE_MM
endif
SHMEM_DEF = 
ifeq (1,$(BOWTIE_SHARED_MEM))
    SHMEM_DEF = -DBOWTIE_SHARED_MEM
endif
PTHREAD_PKG =
PTHREAD_LIB =
PTHREAD_DEF =

ifeq (1,$(MINGW))
	PTHREAD_LIB = 
	EXTRA_FLAGS += -static-libgcc -static-libstdc++
else
	PTHREAD_LIB = -lpthread
endif

PREFETCH_LOCALITY = 2
PREF_DEF = -DPREFETCH_LOCALITY=$(PREFETCH_LOCALITY)

LIBS = $(PTHREAD_LIB)
SEARCH_LIBS = 
BUILD_LIBS =
INSPECT_LIBS = 

ifeq (1,$(MINGW))
    BUILD_LIBS = 
    INSPECT_LIBS = 
endif

OTHER_CPPS = ccnt_lut.cpp ref_read.cpp alphabet.cpp shmem.cpp \
             edit.cpp ebwt.cpp tinythread.cpp
SEARCH_CPPS = qual.cpp pat.cpp ebwt_search_util.cpp ref_aligner.cpp \
              log.cpp hit_set.cpp refmap.cpp annot.cpp sam.cpp \
              color.cpp color_dec.cpp hit.cpp
SEARCH_CPPS_MAIN = $(SEARCH_CPPS) bowtie_main.cpp

BUILD_CPPS =
BUILD_CPPS_MAIN = $(BUILD_CPPS) bowtie_build_main.cpp

SEARCH_FRAGMENTS = $(wildcard search_*_phase*.c)
VERSION = $(shell cat VERSION)

BITS=32
# cygwin will stay 32 bit for now.
ifeq (1,$(MINGW))
    # msys will always be 32 bit so look at the cpu arch.
    ifneq (,$(findstring AMD64,$(PROCESSOR_ARCHITEW6432)))
        BITS=64
    else
        ifneq (,$(findstring AMD64,$(PROCESSOR_ARCHITECTURE)))
            BITS=64
        endif
    endif
endif

ifeq (1,$(LINUX))
    ifeq (x86_64, $(shell uname -p))
        BITS=64
    endif
endif

# Convert BITS=?? to a -m flag
BITS_FLAG =
ifeq (32,$(BITS))
    BITS_FLAG = -m32
endif
ifeq (64,$(BITS))
    BITS_FLAG = -m64
endif

DEBUG_FLAGS = -O0 -g3 $(BITS_FLAG)
RELEASE_FLAGS = -O3 $(BITS_FLAG)
NOASSERT_FLAGS = -DNDEBUG
FILE_FLAGS = -D_LARGEFILE_SOURCE -D_FILE_OFFSET_BITS=64 -D_GNU_SOURCE

BIN_LIST = bowtie-build \
           bowtie \
           bowtie-inspect
BIN_LIST_AUX = bowtie-build-debug \
               bowtie-debug \
               bowtie-inspect-debug

GENERAL_LIST = $(wildcard scripts/*.sh) \
               $(wildcard scripts/*.pl) \
               $(wildcard indexes/e_coli*) \
               $(wildcard genomes/NC_008253.fna) \
               $(wildcard reads/e_coli_1000.*) \
               $(wildcard reads/e_coli_1000_*) \
               SeqAn-1.1 \
               doc/manual.html \
               doc/README \
               doc/style.css \
               reads/e_coli_10000snp.fa \
               reads/e_coli_10000snp.fq \
               $(PTHREAD_PKG) \
               AUTHORS \
               LICENSE \
               NEWS \
               MANUAL \
               MANUAL.markdown \
               TUTORIAL \
               VERSION

SRC_PKG_LIST = $(wildcard *.h) \
               $(wildcard *.hh) \
               $(wildcard *.c) \
               $(wildcard *.cpp) \
               doc/strip_markdown.pl \
               Makefile \
               $(GENERAL_LIST)

BIN_PKG_LIST = $(GENERAL_LIST)

all: $(BIN_LIST)

allall: $(BIN_LIST) $(BIN_LIST_AUX)

DEFS=-fno-strict-aliasing \
     -DBOWTIE_VERSION="\"`cat VERSION`\"" \
     -DBUILD_HOST="\"`hostname`\"" \
     -DBUILD_TIME="\"`date`\"" \
     -DCOMPILER_VERSION="\"`$(CXX) -v 2>&1 | tail -1`\"" \
     $(FILE_FLAGS) \
     $(PTHREAD_DEF) \
     $(PREF_DEF) \
     $(MM_DEF) \
     $(SHMEM_DEF)

ALL_FLAGS = $(EXTRA_FLAGS) $(CFLAGS) $(CXXFLAGS)
DEBUG_DEFS = -DCOMPILER_OPTIONS="\"$(DEBUG_FLAGS) $(ALL_FLAGS)\""
RELEASE_DEFS = -DCOMPILER_OPTIONS="\"$(RELEASE_FLAGS) $(ALL_FLAGS)\""

#
# bowtie-build targets
#

bowtie-build: ebwt_build.cpp $(OTHER_CPPS) $(HEADERS)
	$(CXX) $(RELEASE_FLAGS) $(RELEASE_DEFS) $(ALL_FLAGS)  \
		$(DEFS) $(NOASSERT_FLAGS) -Wall \
		$(INC) \
		-o $@ $< \
		$(OTHER_CPPS) $(BUILD_CPPS_MAIN) \
		$(LIBS) $(BUILD_LIBS)

bowtie-build_prof: ebwt_build.cpp $(OTHER_CPPS) $(HEADERS)
	$(CXX) $(RELEASE_FLAGS) -pg -p -g3 $(RELEASE_DEFS) $(ALL_FLAGS) \
		$(DEFS) $(NOASSERT_FLAGS) -Wall \
		$(INC) \
		-o $@ $< \
		$(OTHER_CPPS) $(BUILD_CPPS_MAIN) \
		$(LIBS) $(BUILD_LIBS)

bowtie-build-debug: ebwt_build.cpp $(OTHER_CPPS) $(HEADERS)
	$(CXX) $(DEBUG_FLAGS) $(DEBUG_DEFS) $(ALL_FLAGS) \
		$(DEFS) -Wall \
		$(INC) \
		-o $@ $< \
		$(OTHER_CPPS) $(BUILD_CPPS_MAIN) \
		$(LIBS) $(BUILD_LIBS)

#
# bowtie targets
#

bowtie: ebwt_search.cpp $(SEARCH_CPPS) $(OTHER_CPPS) $(HEADERS) $(SEARCH_FRAGMENTS)
	$(CXX) $(RELEASE_FLAGS) $(RELEASE_DEFS) $(ALL_FLAGS) \
		$(DEFS) $(NOASSERT_FLAGS) -Wall \
		$(INC) \
		-o $@ $< \
		$(OTHER_CPPS) $(SEARCH_CPPS_MAIN) \
		$(LIBS) $(SEARCH_LIBS)

bowtie_prof: ebwt_search.cpp $(SEARCH_CPPS) $(OTHER_CPPS) $(HEADERS) $(SEARCH_FRAGMENTS)
	$(CXX) $(RELEASE_FLAGS) \
		$(RELEASE_DEFS) -pg -p -g3 $(ALL_FLAGS) \
		$(DEFS) $(NOASSERT_FLAGS) -Wall \
		$(INC) \
		-o $@ $< \
		$(OTHER_CPPS) $(SEARCH_CPPS_MAIN) \
		$(LIBS) $(SEARCH_LIBS)

bowtie-debug: ebwt_search.cpp $(SEARCH_CPPS) $(OTHER_CPPS) $(HEADERS) $(SEARCH_FRAGMENTS)
	$(CXX) $(DEBUG_FLAGS) \
		$(DEBUG_DEFS) $(ALL_FLAGS) \
		$(DEFS) -Wall \
		$(INC) \
		-o $@ $< \
		$(OTHER_CPPS) $(SEARCH_CPPS_MAIN) \
		$(LIBS) $(SEARCH_LIBS)

#
# bowtie-inspect targets
#

bowtie-inspect: bowtie_inspect.cpp $(HEADERS) $(OTHER_CPPS)
	$(CXX) $(RELEASE_FLAGS) \
		$(RELEASE_DEFS) $(ALL_FLAGS) \
		$(DEFS) -Wall \
		$(INC) -I . \
		-o $@ $< \
		$(OTHER_CPPS) \
		$(LIBS)

bowtie-inspect-debug: bowtie_inspect.cpp $(HEADERS) $(OTHER_CPPS) 
	$(CXX) $(DEBUG_FLAGS) \
		$(DEBUG_DEFS) $(ALL_FLAGS) \
		$(DEFS) -Wall \
		$(INC) -I . \
		-o $@ $< \
		$(OTHER_CPPS) \
		$(LIBS)

bowtie-src.zip: $(SRC_PKG_LIST)
	chmod a+x scripts/*.sh scripts/*.pl
	mkdir .src.tmp
	mkdir .src.tmp/bowtie-$(VERSION)
	zip -r tmp.zip $(SRC_PKG_LIST)
	mv tmp.zip .src.tmp/bowtie-$(VERSION)
	cd .src.tmp/bowtie-$(VERSION) ; unzip tmp.zip ; rm -f tmp.zip
	cd .src.tmp ; zip -r $@ bowtie-$(VERSION)
	cp .src.tmp/$@ .
	rm -rf .src.tmp

bowtie-bin.zip: $(BIN_PKG_LIST) $(BIN_LIST) $(BIN_LIST_AUX) 
	chmod a+x scripts/*.sh scripts/*.pl
	rm -rf .bin.tmp
	mkdir .bin.tmp
	mkdir .bin.tmp/bowtie-$(VERSION)
	if [ -f bowtie.exe ] ; then \
		zip tmp.zip $(BIN_PKG_LIST) $(addsuffix .exe,$(BIN_LIST) $(BIN_LIST_AUX)) ; \
	else \
		zip tmp.zip $(BIN_PKG_LIST) $(BIN_LIST) $(BIN_LIST_AUX) ; \
	fi
	mv tmp.zip .bin.tmp/bowtie-$(VERSION)
	cd .bin.tmp/bowtie-$(VERSION) ; unzip tmp.zip ; rm -f tmp.zip
	cd .bin.tmp ; zip -r $@ bowtie-$(VERSION)
	cp .bin.tmp/$@ .
	rm -rf .bin.tmp

.PHONY: doc
doc: doc/manual.html MANUAL

doc/manual.html: MANUAL.markdown
	echo "<h1>Table of Contents</h1>" > .tmp.head
	pandoc -T "Bowtie Manual" -B .tmp.head \
	       --css style.css -o $@ \
	       --from markdown --to HTML \
	       --table-of-contents $^

MANUAL: MANUAL.markdown
	perl doc/strip_markdown.pl < $^ > $@

.PHONY: clean
clean:
	rm -f $(BIN_LIST) $(BIN_LIST_AUX) \
	bowtie_prof \
	$(addsuffix .exe,$(BIN_LIST) $(BIN_LIST_AUX) bowtie_prof) \
	bowtie-src.zip bowtie-bin.zip
	rm -f core.*

## bowtie 0.12.7

=== debian/changelog ===
bowtie (0.12.7-3) unstable; urgency=low

  * debian/patches/use-dpkg-buildflags.patch: Regard LDFLAGS/CPPFLAGS
    hardening flags (thanks for the patch to Simon Ruderich
    <simon@ruderich.org>)
    Closes: #670230

 -- Andreas Tille <tille@debian.org>  Tue, 24 Apr 2012 13:21:32 +0200

bowtie (0.12.7-2) unstable; urgency=low

  * Do not give a pointer to non existing info pages in manpages
  * debian/control:
     - fixed Vcs fields
     - Standards-Version: 3.9.3 (no changes needed)
  * debian/upstream: Add citation information
  * debian/rules: calculate pkg name instead of setting it
  * debian/copyright: DEP5 verified using
     cme fix dpkg-copyright
  * debian/patches/gcc-4.7.patch: function "reverseInPlace" is declared after
    the function is used
    Thanks to Rodolfo García Peñas <kix@kix.es> and
    gregor herrmann <gregoa@debian.org>
    Closes: #667120
  * debhelper 9 (control+compat)
    Hardening flags were explicitly tested but not enforced in debian/rules

 -- Andreas Tille <tille@debian.org>  Sun, 22 Apr 2012 21:09:05 +0200

bowtie (0.12.7-1) unstable; urgency=low

  * Initial release (Closes: #604940)

 -- Andreas Tille <tille@debian.org>  Wed, 02 Feb 2011 13:47:12 +0100

=== debian/control ===
Source: bowtie
Section: science
Priority: extra
Maintainer:  Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
DM-Upload-Allowed: yes
Uploaders: Steffen Moeller <moeller@debian.org>,
 Yask Gupta <yask.gupta87@gmail.com>,
 Andreas Tille <tille@debian.org>
Build-Depends: debhelper (>= 9), help2man
Standards-Version: 3.9.3
Homepage: http://bowtie-bio.sourceforge.net/
Vcs-Svn: svn://svn.debian.org/debian-med/trunk/packages/bowtie/trunk
Vcs-Browser: http://svn.debian.org/wsvn/debian-med/trunk/packages/bowtie/trunk/

Package: bowtie
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: bowtie-examples
Description: ultrafast memory-efficient short read aligner
 This package addresses the problem to interpret the results from the
 latest (2010) DNA sequencing technologies. Those will yield fairly
 short stretches and those cannot be interpreted directly. It is the
 challenge for tools like Bowtie to give a chromosomal location to the
 short stretches of DNA sequenced per run.
 .
 Bowtie aligns short DNA sequences (reads) to the human genome at a rate
 of over 25 million 35-bp reads per hour. Bowtie indexes the genome with
 a Burrows-Wheeler index to keep its memory footprint small: typically
 about 2.2 GB for the human genome (2.9 GB for paired-end).

Package: bowtie-examples
Architecture: all
Depends: ${misc:Depends}
Recommends: bowtie
Enhances: bowtie
Description: Examples for bowtie, the ultrafast memory-efficient short read aligner
 This package addresses the problem to interpret the results from the
 latest (2010) DNA sequencing technologies. Those will yield fairly
 short stretches and those cannot be interpreted directly. It is the
 challenge for tools like Bowtie to give a chromosomal location to the
 short stretches of DNA sequenced per run.
 .
 Bowtie aligns short DNA sequences (reads) to the human genome at a rate
 of over 25 million 35-bp reads per hour. Bowtie indexes the genome with
 a Burrows-Wheeler index to keep its memory footprint small: typically
 about 2.2 GB for the human genome (2.9 GB for paired-end).
 .
 This package provides some example data to work with bowtie.

=== debian/rules ===
#!/usr/bin/make -f
# debian/rules for bowtie
# Andreas Tille <tille@debian.org>
# GPL

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# export DEB_BUILD_MAINT_OPTIONS = hardening=+all

pkg := $(shell dpkg-parsechangelog | sed -n 's/^Source: //p')

%:
	dh $@

override_dh_auto_build:
	$(MAKE) allall

override_dh_auto_install:
	help2man --name="ultrafast memory-efficient short read aligner" --no-info \
             $(CURDIR)/bowtie > $(CURDIR)/debian/$(pkg)/usr/share/man/man1/bowtie.1
	help2man --name="building a colorspace index for bowtie" --no-info \
             $(CURDIR)/bowtie-build > $(CURDIR)/debian/$(pkg)/usr/share/man/man1/bowtie-build.1
	help2man --name="extracts information from a bowtie index" --no-info \
             $(CURDIR)/bowtie-inspect > $(CURDIR)/debian/$(pkg)/usr/share/man/man1/bowtie-inspect.1

override_dh_auto_clean:
	rm -f .bowtie*
	dh_auto_clean

get-orig-source:
	. debian/get-orig-source

## bowtie 1.0.0

=== debian/changelog ===
bowtie (1.0.0-5) unstable; urgency=low

  * Fixed (hopefully) FTBFS by using override_dh_fixperms-indep target
    instead of override_dh_fixperms in debian/rules.

 -- Ognyan Kulev <ogi@debian.org>  Thu, 30 May 2013 09:41:25 +0300

bowtie (1.0.0-4) unstable; urgency=low

  * Lintian fixes:
    - Removed DM-Upload-Allowed field.
    - Standards Version 3.9.4 (no changes needed).
    - Remove execute bits on some files in bowtie-examples.
  * Don't compress *.ebwt index files in bowtie-examples package.
  * Package description now starts with a capital letter.
  
 -- Ognyan Kulev <ogi@debian.org>  Wed, 29 May 2013 22:53:13 +0300

bowtie (1.0.0-3) unstable; urgency=low

  * New patch no_hash_style_both_for_mips.patch.
    This fixes build errors on mips and mipsel.

 -- Ognyan Kulev <ogi@debian.org>  Wed, 24 Apr 2013 15:15:37 +0300

bowtie (1.0.0-2) unstable; urgency=low

  * Requires version 1.3 of SeqAn.
  * Updated README.source about using Debian's SeqAn library.
  * Removed machine_bits_detection.patch and added disable_bits_flag.patch.

 -- Ognyan Kulev <ogi@debian.org>  Wed, 24 Apr 2013 10:49:47 +0300

bowtie (1.0.0-1) unstable; urgency=low

  * New upstream version. (Closes: #705616)
  * Refreshed patches: use_debian_seqan.patch, use-dpkg-buildflags.patch.
  * Removed patch gcc-4.7.patch (fixed upstream).
  * New patch machine_bits_detection.patch.
  * Added build dependancy on seqan-dev.
  * Activated use_debian_seqan.patch and added the following patches:
    - seqan-fix-setBegin-call.patch
    - seqan-rename-ChunkPool.patch
    - seqan-rename-fill-to-resize.patch
  * Added myself to Uploaders control field.

 -- Ognyan Kulev <ogi@debian.org>  Tue, 23 Apr 2013 16:43:49 +0300

=== debian/control ===
--- 
+++ 
@@ -2,12 +2,12 @@
 Section: science
 Priority: extra
 Maintainer:  Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
-DM-Upload-Allowed: yes
 Uploaders: Steffen Moeller <moeller@debian.org>,
  Yask Gupta <yask.gupta87@gmail.com>,
- Andreas Tille <tille@debian.org>
-Build-Depends: debhelper (>= 9), help2man
-Standards-Version: 3.9.3
+ Andreas Tille <tille@debian.org>,
+ Ognyan Kulev <ogi@debian.org>
+Build-Depends: debhelper (>= 9), help2man, seqan-dev (>= 1.3)
+Standards-Version: 3.9.4
 Homepage: http://bowtie-bio.sourceforge.net/
 Vcs-Svn: svn://svn.debian.org/debian-med/trunk/packages/bowtie/trunk
 Vcs-Browser: http://svn.debian.org/wsvn/debian-med/trunk/packages/bowtie/trunk/
@@ -16,7 +16,7 @@
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Suggests: bowtie-examples
-Description: ultrafast memory-efficient short read aligner
+Description: Ultrafast memory-efficient short read aligner
  This package addresses the problem to interpret the results from the
  latest (2010) DNA sequencing technologies. Those will yield fairly
  short stretches and those cannot be interpreted directly. It is the

=== debian/rules ===
--- 
+++ 
@@ -24,6 +24,16 @@
 	help2man --name="extracts information from a bowtie index" --no-info \
              $(CURDIR)/bowtie-inspect > $(CURDIR)/debian/$(pkg)/usr/share/man/man1/bowtie-inspect.1
 
+override_dh_compress:
+	dh_compress -X.ebwt
+
+# Fix bowtie-examples access mode for files in examples/
+override_dh_fixperms-indep:
+	dh_fixperms
+	chmod 644 debian/bowtie-examples/usr/share/doc/bowtie/examples/indexes/*
+#	Following line is not needed because gzipped genome/ (by dh_compress) is always 644.
+#	chmod 644 debian/bowtie-examples/usr/share/doc/bowtie/examples/genomes/*
+
 override_dh_auto_clean:
 	rm -f .bowtie*
 	dh_auto_clean

## bowtie 1.0.1

=== debian/changelog ===
bowtie (1.0.1-1) unstable; urgency=medium

  * New upstream version (adapted patches)
  * drop debian/get-orig-source but rather remove the SeqAn-1.1 code
    copy via Files-Excluded
  * debian/control: Priority: optional

 -- Andreas Tille <tille@debian.org>  Wed, 30 Jul 2014 13:38:25 +0200

bowtie (1.0.0-6) unstable; urgency=low

  * debian/patches/seqan-popcount.patch: New patch. (Closes: #733398)
  * Version 1.4 of seqan-dev is required now.
  * Standards-Version: 3.9.5 (no changes needed).
  * Updated Vcs-Svn and Vcs-Browse fields as per Debian-Med policy.

 -- Ognyan Kulev <ogi@debian.org>  Sat, 08 Mar 2014 15:13:16 +0200

=== debian/control ===
--- 
+++ 
@@ -1,16 +1,16 @@
 Source: bowtie
 Section: science
-Priority: extra
+Priority: optional
 Maintainer:  Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
 Uploaders: Steffen Moeller <moeller@debian.org>,
  Yask Gupta <yask.gupta87@gmail.com>,
  Andreas Tille <tille@debian.org>,
  Ognyan Kulev <ogi@debian.org>
-Build-Depends: debhelper (>= 9), help2man, seqan-dev (>= 1.3)
-Standards-Version: 3.9.4
+Build-Depends: debhelper (>= 9), help2man, seqan-dev (>= 1.4)
+Standards-Version: 3.9.5
 Homepage: http://bowtie-bio.sourceforge.net/
-Vcs-Svn: svn://svn.debian.org/debian-med/trunk/packages/bowtie/trunk
-Vcs-Browser: http://svn.debian.org/wsvn/debian-med/trunk/packages/bowtie/trunk/
+Vcs-Svn: svn://anonscm.debian.org/debian-med/trunk/packages/bowtie/trunk/
+Vcs-Browser: http://anonscm.debian.org/viewvc/debian-med/trunk/packages/bowtie/trunk/
 
 Package: bowtie
 Architecture: any

=== debian/rules ===
--- 
+++ 
@@ -39,4 +39,4 @@
 	dh_auto_clean
 
 get-orig-source:
-	. debian/get-orig-source
+	uscan --verbose --force-download --repack --compress xz

## bowtie 1.1.1

=== Makefile ===
--- 
+++ 
@@ -4,7 +4,7 @@
 
 SEQAN_DIR = SeqAn-1.1
 SEQAN_INC = -I $(SEQAN_DIR)
-INC = $(SEQAN_INC)
+INC = $(SEQAN_INC) -I third_party
 CPP = g++
 CXX = $(CPP)
 CC = gcc
@@ -42,6 +42,12 @@
     MACOS = 1
 endif
 
+ifneq (,$(findstring 13,$(shell uname -r)))
+	CPP = clang++
+	CC = clang
+	EXTRA_FLAGS += -stdlib=libstdc++
+endif
+
 LINUX = 0
 ifneq (,$(findstring Linux,$(shell uname)))
     LINUX = 1
@@ -64,7 +70,13 @@
 	PTHREAD_LIB = 
 	EXTRA_FLAGS += -static-libgcc -static-libstdc++
 else
-	PTHREAD_LIB = -lpthread
+    PTHREAD_LIB = -lpthread
+endif
+
+POPCNT_CAPABILITY ?= 1
+ifeq (1, $(POPCNT_CAPABILITY))
+    EXTRA_FLAGS += -DPOPCNT_CAPABILITY
+    INC += -I third_party
 endif
 
 PREFETCH_LOCALITY = 2
@@ -94,16 +106,14 @@
 VERSION = $(shell cat VERSION)
 
 BITS=32
-# cygwin will stay 32 bit for now.
-ifeq (1,$(MINGW))
-    # msys will always be 32 bit so look at the cpu arch.
-    ifneq (,$(findstring AMD64,$(PROCESSOR_ARCHITEW6432)))
-        BITS=64
-    else
-        ifneq (,$(findstring AMD64,$(PROCESSOR_ARCHITECTURE)))
-            BITS=64
-        endif
-    endif
+ifeq (x86_64,$(shell uname -m))
+	BITS=64
+endif
+# msys will always be 32 bit so look at the cpu arch instead.
+ifneq (,$(findstring AMD64,$(PROCESSOR_ARCHITEW6432)))
+	ifeq (1,$(MINGW))
+		BITS=64
+	endif
 endif
 
 ifeq (1,$(LINUX))
@@ -112,34 +122,39 @@
     endif
 endif
 
-# Convert BITS=?? to a -m flag
-BITS_FLAG =
 ifeq (32,$(BITS))
-    BITS_FLAG = -m32
-endif
-ifeq (64,$(BITS))
-    BITS_FLAG = -m64
-endif
-
-DEBUG_FLAGS = -O0 -g3 $(BITS_FLAG)
-RELEASE_FLAGS = -O3 $(BITS_FLAG)
+    $(error bowtie2 compilation requires a 64-bit platform )
+endif
+
+DEBUG_FLAGS = -O0 -g3 -m64
+RELEASE_FLAGS = -O3 -m64
 NOASSERT_FLAGS = -DNDEBUG
 FILE_FLAGS = -D_LARGEFILE_SOURCE -D_FILE_OFFSET_BITS=64 -D_GNU_SOURCE
 
-BIN_LIST = bowtie-build \
-           bowtie \
-           bowtie-inspect
-BIN_LIST_AUX = bowtie-build-debug \
-               bowtie-debug \
-               bowtie-inspect-debug
+BIN_LIST = bowtie-build-s \
+           bowtie-build-l \
+           bowtie-align-s \
+           bowtie-align-l \
+           bowtie-inspect-s \
+           bowtie-inspect-l
+BIN_LIST_AUX = bowtie-build-s-debug \
+               bowtie-build-l-debug \
+               bowtie-align-s-debug \
+               bowtie-align-l-debug \
+               bowtie-inspect-s-debug \
+               bowtie-inspect-l-debug
 
 GENERAL_LIST = $(wildcard scripts/*.sh) \
                $(wildcard scripts/*.pl) \
+               $(wildcard scripts/*.py) \
                $(wildcard indexes/e_coli*) \
                $(wildcard genomes/NC_008253.fna) \
                $(wildcard reads/e_coli_1000.*) \
                $(wildcard reads/e_coli_1000_*) \
                SeqAn-1.1 \
+               bowtie \
+               bowtie-build \
+               bowtie-inspect \
                doc/manual.html \
                doc/README \
                doc/style.css \
@@ -158,6 +173,10 @@
                $(wildcard *.hh) \
                $(wildcard *.c) \
                $(wildcard *.cpp) \
+               $(wildcard third_party/*.h) \
+               $(wildcard third_party/*.hh) \
+               $(wildcard third_party/*.c) \
+               $(wildcard third_party/*.cpp) \
                doc/strip_markdown.pl \
                Makefile \
                $(GENERAL_LIST)
@@ -187,9 +206,17 @@
 # bowtie-build targets
 #
 
-bowtie-build: ebwt_build.cpp $(OTHER_CPPS) $(HEADERS)
+bowtie-build-s: ebwt_build.cpp $(OTHER_CPPS) $(HEADERS)
 	$(CXX) $(RELEASE_FLAGS) $(RELEASE_DEFS) $(ALL_FLAGS)  \
 		$(DEFS) $(NOASSERT_FLAGS) -Wall \
+		$(INC) \
+		-o $@ $< \
+		$(OTHER_CPPS) $(BUILD_CPPS_MAIN) \
+		$(LIBS) $(BUILD_LIBS)
+
+bowtie-build-l: ebwt_build.cpp $(OTHER_CPPS) $(HEADERS)
+	$(CXX) $(RELEASE_FLAGS) $(RELEASE_DEFS) $(ALL_FLAGS)  \
+		$(DEFS) -DBOWTIE_64BIT_INDEX $(NOASSERT_FLAGS) -Wall \
 		$(INC) \
 		-o $@ $< \
 		$(OTHER_CPPS) $(BUILD_CPPS_MAIN) \
@@ -203,7 +230,7 @@
 		$(OTHER_CPPS) $(BUILD_CPPS_MAIN) \
 		$(LIBS) $(BUILD_LIBS)
 
-bowtie-build-debug: ebwt_build.cpp $(OTHER_CPPS) $(HEADERS)
+bowtie-build-s-debug: ebwt_build.cpp $(OTHER_CPPS) $(HEADERS)
 	$(CXX) $(DEBUG_FLAGS) $(DEBUG_DEFS) $(ALL_FLAGS) \
 		$(DEFS) -Wall \
 		$(INC) \
@@ -211,13 +238,29 @@
 		$(OTHER_CPPS) $(BUILD_CPPS_MAIN) \
 		$(LIBS) $(BUILD_LIBS)
 
+bowtie-build-l-debug: ebwt_build.cpp $(OTHER_CPPS) $(HEADERS)
+	$(CXX) $(DEBUG_FLAGS) $(DEBUG_DEFS) $(ALL_FLAGS) \
+		$(DEFS) -DBOWTIE_64BIT_INDEX -Wall \
+		$(INC) \
+		-o $@ $< \
+		$(OTHER_CPPS) $(BUILD_CPPS_MAIN) \
+		$(LIBS) $(BUILD_LIBS)
+
 #
 # bowtie targets
 #
 
-bowtie: ebwt_search.cpp $(SEARCH_CPPS) $(OTHER_CPPS) $(HEADERS) $(SEARCH_FRAGMENTS)
+bowtie-align-s: ebwt_search.cpp $(SEARCH_CPPS) $(OTHER_CPPS) $(HEADERS) $(SEARCH_FRAGMENTS)
 	$(CXX) $(RELEASE_FLAGS) $(RELEASE_DEFS) $(ALL_FLAGS) \
 		$(DEFS) $(NOASSERT_FLAGS) -Wall \
+		$(INC) \
+		-o $@ $< \
+		$(OTHER_CPPS) $(SEARCH_CPPS_MAIN) \
+		$(LIBS) $(SEARCH_LIBS)
+
+bowtie-align-l: ebwt_search.cpp $(SEARCH_CPPS) $(OTHER_CPPS) $(HEADERS) $(SEARCH_FRAGMENTS)
+	$(CXX) $(RELEASE_FLAGS) $(RELEASE_DEFS) $(ALL_FLAGS) \
+		$(DEFS) $(NOASSERT_FLAGS) -DBOWTIE_64BIT_INDEX -Wall \
 		$(INC) \
 		-o $@ $< \
 		$(OTHER_CPPS) $(SEARCH_CPPS_MAIN) \
@@ -232,7 +275,7 @@
 		$(OTHER_CPPS) $(SEARCH_CPPS_MAIN) \
 		$(LIBS) $(SEARCH_LIBS)
 
-bowtie-debug: ebwt_search.cpp $(SEARCH_CPPS) $(OTHER_CPPS) $(HEADERS) $(SEARCH_FRAGMENTS)
+bowtie-align-s-debug: ebwt_search.cpp $(SEARCH_CPPS) $(OTHER_CPPS) $(HEADERS) $(SEARCH_FRAGMENTS)
 	$(CXX) $(DEBUG_FLAGS) \
 		$(DEBUG_DEFS) $(ALL_FLAGS) \
 		$(DEFS) -Wall \
@@ -241,11 +284,20 @@
 		$(OTHER_CPPS) $(SEARCH_CPPS_MAIN) \
 		$(LIBS) $(SEARCH_LIBS)
 
+bowtie-align-l-debug: ebwt_search.cpp $(SEARCH_CPPS) $(OTHER_CPPS) $(HEADERS) $(SEARCH_FRAGMENTS)
+	$(CXX) $(DEBUG_FLAGS) \
+		$(DEBUG_DEFS) $(ALL_FLAGS) \
+		$(DEFS) -DBOWTIE_64BIT_INDEX -Wall \
+		$(INC) \
+		-o $@ $< \
+		$(OTHER_CPPS) $(SEARCH_CPPS_MAIN) \
+		$(LIBS) $(SEARCH_LIBS)
+
 #
 # bowtie-inspect targets
 #
 
-bowtie-inspect: bowtie_inspect.cpp $(HEADERS) $(OTHER_CPPS)
+bowtie-inspect-s: bowtie_inspect.cpp $(HEADERS) $(OTHER_CPPS)
 	$(CXX) $(RELEASE_FLAGS) \
 		$(RELEASE_DEFS) $(ALL_FLAGS) \
 		$(DEFS) -Wall \
@@ -254,10 +306,28 @@
 		$(OTHER_CPPS) \
 		$(LIBS)
 
-bowtie-inspect-debug: bowtie_inspect.cpp $(HEADERS) $(OTHER_CPPS) 
+bowtie-inspect-l: bowtie_inspect.cpp $(HEADERS) $(OTHER_CPPS)
+	$(CXX) $(RELEASE_FLAGS) \
+		$(RELEASE_DEFS) $(ALL_FLAGS) \
+		$(DEFS) -DBOWTIE_64BIT_INDEX -Wall \
+		$(INC) -I . \
+		-o $@ $< \
+		$(OTHER_CPPS) \
+		$(LIBS)
+
+bowtie-inspect-s-debug: bowtie_inspect.cpp $(HEADERS) $(OTHER_CPPS) 
 	$(CXX) $(DEBUG_FLAGS) \
 		$(DEBUG_DEFS) $(ALL_FLAGS) \
 		$(DEFS) -Wall \
+		$(INC) -I . \
+		-o $@ $< \
+		$(OTHER_CPPS) \
+		$(LIBS)
+
+bowtie-inspect-l-debug: bowtie_inspect.cpp $(HEADERS) $(OTHER_CPPS) 
+	$(CXX) $(DEBUG_FLAGS) \
+		$(DEBUG_DEFS) $(ALL_FLAGS) \
+		$(DEFS) -DBOWTIE_64BIT_INDEX -Wall \
 		$(INC) -I . \
 		-o $@ $< \
 		$(OTHER_CPPS) \
@@ -279,7 +349,7 @@
 	rm -rf .bin.tmp
 	mkdir .bin.tmp
 	mkdir .bin.tmp/bowtie-$(VERSION)
-	if [ -f bowtie.exe ] ; then \
+	if [ -f bowtie-align-s.exe ] ; then \
 		zip tmp.zip $(BIN_PKG_LIST) $(addsuffix .exe,$(BIN_LIST) $(BIN_LIST_AUX)) ; \
 	else \
 		zip tmp.zip $(BIN_PKG_LIST) $(BIN_LIST) $(BIN_LIST_AUX) ; \

=== debian/changelog ===
bowtie (1.1.1-2) unstable; urgency=high

  * Team upload.
  * Install missing commands.  Closes: #776881.

 -- Charles Plessy <plessy@debian.org>  Tue, 03 Feb 2015 10:44:39 +0900

bowtie (1.1.1-1) unstable; urgency=medium

  * New upstream release
  * cme fix dpkg-control
  * Another patch to build with SeqAn 1.4 (Thanks to Gert Wollny)
  * Add Depends: python (also Build-Depends since it is used in tests)

 -- Andreas Tille <tille@debian.org>  Thu, 02 Oct 2014 14:32:50 +0200

bowtie (1.0.1-3) unstable; urgency=medium

  * Drop all architectures except amd64 since there was no success
    in trying to port the code to other architectures.  The portability
    patch introduced in the last revision was droped again
  * debian/copyright: Drop unneeded copyright statements about code that
    was removed from upstream source

 -- Andreas Tille <tille@debian.org>  Mon, 15 Sep 2014 11:00:25 +0200

bowtie (1.0.1-2) unstable; urgency=medium

  * Do not use copy of outdated gcc header file which destroys portability
    to other architectures
    Closes: #756780
  * Add README.Debian informing users about the fact that we ignore copy
    of cpuid.h
  * Add unit tests for build time and autopkgtest
  * Add debian/README.test to explain how to test the package
    Attention: Please take notice of /usr/share/bowtie/README.Debian about
      "Test suite for bowtie created and potential issue with sorting"

 -- Andreas Tille <tille@debian.org>  Wed, 03 Sep 2014 09:50:22 +0200

=== debian/control ===
--- 
+++ 
@@ -1,20 +1,25 @@
 Source: bowtie
+Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
+Uploaders: Steffen Moeller <moeller@debian.org>,
+           Yask Gupta <yask.gupta87@gmail.com>,
+           Andreas Tille <tille@debian.org>,
+           Ognyan Kulev <ogi@debian.org>
 Section: science
 Priority: optional
-Maintainer:  Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
-Uploaders: Steffen Moeller <moeller@debian.org>,
- Yask Gupta <yask.gupta87@gmail.com>,
- Andreas Tille <tille@debian.org>,
- Ognyan Kulev <ogi@debian.org>
-Build-Depends: debhelper (>= 9), help2man, seqan-dev (>= 1.4)
-Standards-Version: 3.9.5
+Build-Depends: debhelper (>= 9),
+               help2man,
+               seqan-dev (>= 1.4),
+               python
+Standards-Version: 3.9.6
+Vcs-Browser: http://anonscm.debian.org/viewvc/debian-med/trunk/packages/bowtie/trunk/
+Vcs-Svn: svn://anonscm.debian.org/debian-med/trunk/packages/bowtie/trunk/
 Homepage: http://bowtie-bio.sourceforge.net/
-Vcs-Svn: svn://anonscm.debian.org/debian-med/trunk/packages/bowtie/trunk/
-Vcs-Browser: http://anonscm.debian.org/viewvc/debian-med/trunk/packages/bowtie/trunk/
 
 Package: bowtie
-Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}
+Architecture: amd64 kfreebsd-amd64
+Depends: ${shlibs:Depends},
+         ${misc:Depends},
+         python
 Suggests: bowtie-examples
 Description: Ultrafast memory-efficient short read aligner
  This package addresses the problem to interpret the results from the

=== debian/rules ===
--- 
+++ 
@@ -38,5 +38,10 @@
 	rm -f .bowtie*
 	dh_auto_clean
 
+override_dh_auto_test:
+	ln -s debian/tests
+	sh debian/tests/run-unit-test test_at_build_time
+	rm -f tests examples[0-9].out
+
 get-orig-source:
 	uscan --verbose --force-download --repack --compress xz

## bowtie 1.1.2

=== Makefile ===
--- 
+++ 
@@ -1,6 +1,9 @@
 #
 # Makefile for bowtie, bowtie-build, bowtie-inspect
 #
+
+prefix = /usr/local
+bindir = $(prefix)/bin
 
 SEQAN_DIR = SeqAn-1.1
 SEQAN_INC = -I $(SEQAN_DIR)
@@ -40,12 +43,16 @@
 MACOS = 0
 ifneq (,$(findstring Darwin,$(shell uname)))
     MACOS = 1
-endif
-
-ifneq (,$(findstring 13,$(shell uname -r)))
-	CPP = clang++
-	CC = clang
-	EXTRA_FLAGS += -stdlib=libstdc++
+	ifneq (,$(findstring 13,$(shell uname -r)))
+		CPP = clang++
+		CC = clang
+		EXTRA_FLAGS += -stdlib=libstdc++
+	endif
+	ifneq (,$(findstring 14,$(shell uname -r)))
+		CPP = clang++
+		CC = clang
+		EXTRA_FLAGS += -stdlib=libstdc++
+	endif
 endif
 
 LINUX = 0
@@ -82,7 +89,13 @@
 PREFETCH_LOCALITY = 2
 PREF_DEF = -DPREFETCH_LOCALITY=$(PREFETCH_LOCALITY)
 
-LIBS = $(PTHREAD_LIB)
+ifeq (1,$(WITH_TBB))
+	LIBS = $(PTHREAD_LIB) -ltbb -ltbbmalloc_proxy
+	EXTRA_FLAGS += -DWITH_TBB
+else
+	LIBS = $(PTHREAD_LIB)
+endif
+
 SEARCH_LIBS = 
 BUILD_LIBS =
 INSPECT_LIBS = 
@@ -93,7 +106,11 @@
 endif
 
 OTHER_CPPS = ccnt_lut.cpp ref_read.cpp alphabet.cpp shmem.cpp \
-             edit.cpp ebwt.cpp tinythread.cpp
+             edit.cpp ebwt.cpp
+ifneq (1,$(WITH_TBB))
+	OTHER_CPPS += tinythread.cpp
+endif
+
 SEARCH_CPPS = qual.cpp pat.cpp ebwt_search_util.cpp ref_aligner.cpp \
               log.cpp hit_set.cpp refmap.cpp annot.cpp sam.cpp \
               color.cpp color_dec.cpp hit.cpp
@@ -373,6 +390,14 @@
 MANUAL: MANUAL.markdown
 	perl doc/strip_markdown.pl < $^ > $@
 
+.PHONY: install
+install: all
+	mkdir -p $(DESTDIR)$(bindir)
+	for file in $(BIN_LIST) bowtie-inspect bowtie-build bowtie ; do \
+		cp -f $$file $(DESTDIR)$(bindir) ; \
+	done
+
+
 .PHONY: clean
 clean:
 	rm -f $(BIN_LIST) $(BIN_LIST_AUX) \

=== debian/changelog ===
bowtie (1.1.2-3) unstable; urgency=medium

  * Enable building arch independent packages separately
    Closes: #806220
  * Fix clean target

 -- Andreas Tille <tille@debian.org>  Wed, 25 Nov 2015 22:38:02 +0100

bowtie (1.1.2-2) unstable; urgency=medium

  * Enable building on arm64 (Thanks for the patch to Edmund Grimley Evans)
    Closes: #800548
  * Remove inactive Uploader
  * Fix spelling

 -- Andreas Tille <tille@debian.org>  Thu, 01 Oct 2015 09:47:23 +0200

bowtie (1.1.2-1) unstable; urgency=medium

  * New upstream version
  * remove strange byte-compyled Python code bowtie-buildc (no idea how and
    why it was created)
  * Enabling ppc64el on Makefile and debian/control (Thanks for the patch to
    Fernando Seiti Furusato <ferseiti@br.ibm.com>)
    Closes: #788537

 -- Andreas Tille <tille@debian.org>  Sun, 05 Jul 2015 21:24:20 +0200

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,6 @@
 Source: bowtie
 Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
 Uploaders: Steffen Moeller <moeller@debian.org>,
-           Yask Gupta <yask.gupta87@gmail.com>,
            Andreas Tille <tille@debian.org>,
            Ognyan Kulev <ogi@debian.org>
 Section: science
@@ -16,7 +15,7 @@
 Homepage: http://bowtie-bio.sourceforge.net/
 
 Package: bowtie
-Architecture: amd64 kfreebsd-amd64
+Architecture: amd64 kfreebsd-amd64 arm64 ppc64el
 Depends: ${shlibs:Depends},
          ${misc:Depends},
          python

=== debian/rules ===
--- 
+++ 
@@ -16,7 +16,11 @@
 override_dh_auto_build:
 	$(MAKE) allall
 
-override_dh_auto_install:
+override_dh_auto_install-arch:
+	# remove strange byte-compyled Python code bowtie-buildc (no idea how and why it was created)
+	find . -name bowtie-buildc -delete
+
+override_dh_installman-arch:
 	help2man --name="ultrafast memory-efficient short read aligner" --no-info \
              $(CURDIR)/bowtie > $(CURDIR)/debian/$(pkg)/usr/share/man/man1/bowtie.1
 	help2man --name="building a colorspace index for bowtie" --no-info \

=== debian/watch ===
version=3
http://sf.net/bowtie-bio/bowtie-([\d\.]+)-src\.zip

## bowtie 1.2.0+dfsg

=== Makefile ===
--- 
+++ 
@@ -8,7 +8,7 @@
 SEQAN_DIR = SeqAn-1.1
 SEQAN_INC = -I $(SEQAN_DIR)
 INC = $(SEQAN_INC) -I third_party
-CPP = g++
+CPP = g++ -w
 CXX = $(CPP)
 CC = gcc
 HEADERS = $(wildcard *.h)
@@ -43,29 +43,26 @@
 MACOS = 0
 ifneq (,$(findstring Darwin,$(shell uname)))
     MACOS = 1
-	ifneq (,$(findstring 13,$(shell uname -r)))
+    MACOS_VER_MAJOR = $(shell uname -r | cut -d. -f1)
+    MACOS_VER_GT_12 = $(shell [ $(MACOS_VER_MAJOR) -gt 12 ] && echo true)
+	ifeq (true, $(MACOS_VER_GT_12))
 		CPP = clang++
 		CC = clang
-		EXTRA_FLAGS += -stdlib=libstdc++
-	endif
-	ifneq (,$(findstring 14,$(shell uname -r)))
-		CPP = clang++
-		CC = clang
-		EXTRA_FLAGS += -stdlib=libstdc++
+		override EXTRA_FLAGS += -stdlib=libstdc++
 	endif
 endif
 
 LINUX = 0
 ifneq (,$(findstring Linux,$(shell uname)))
     LINUX = 1
-    EXTRA_FLAGS += -Wl,--hash-style=both
-endif
-
-MM_DEF = 
+    override EXTRA_FLAGS += -Wl,--hash-style=both
+endif
+
+MM_DEF =
 ifeq (1,$(BOWTIE_MM))
     MM_DEF = -DBOWTIE_MM
 endif
-SHMEM_DEF = 
+SHMEM_DEF =
 ifeq (1,$(BOWTIE_SHARED_MEM))
     SHMEM_DEF = -DBOWTIE_SHARED_MEM
 endif
@@ -73,41 +70,76 @@
 PTHREAD_LIB =
 PTHREAD_DEF =
 
+#if we're not using TBB, then we can't use queuing locks
+ifeq (1,$(NO_TBB))
+	NO_QUEUELOCK=1
+endif
+
 ifeq (1,$(MINGW))
-	PTHREAD_LIB = 
-	EXTRA_FLAGS += -static-libgcc -static-libstdc++
+	PTHREAD_LIB =
+	override EXTRA_FLAGS += -static-libgcc -static-libstdc++
 else
     PTHREAD_LIB = -lpthread
 endif
 
+ifeq (1,$(NO_SPINLOCK))
+	override EXTRA_FLAGS += -DNO_SPINLOCK
+endif
+
+#default is to use Intel TBB
+ifneq (1,$(NO_TBB))
+	LIBS = $(PTHREAD_LIB) -ltbb -ltbbmalloc_proxy
+	override EXTRA_FLAGS += -DWITH_TBB
+else
+	LIBS = $(PTHREAD_LIB)
+endif
+
 POPCNT_CAPABILITY ?= 1
 ifeq (1, $(POPCNT_CAPABILITY))
-    EXTRA_FLAGS += -DPOPCNT_CAPABILITY
+    override EXTRA_FLAGS += -DPOPCNT_CAPABILITY
     INC += -I third_party
 endif
 
 PREFETCH_LOCALITY = 2
 PREF_DEF = -DPREFETCH_LOCALITY=$(PREFETCH_LOCALITY)
 
-ifeq (1,$(WITH_TBB))
-	LIBS = $(PTHREAD_LIB) -ltbb -ltbbmalloc_proxy
-	EXTRA_FLAGS += -DWITH_TBB
-else
-	LIBS = $(PTHREAD_LIB)
-endif
-
-SEARCH_LIBS = 
+
+SEARCH_LIBS =
 BUILD_LIBS =
-INSPECT_LIBS = 
+INSPECT_LIBS =
 
 ifeq (1,$(MINGW))
-    BUILD_LIBS = 
-    INSPECT_LIBS = 
+    BUILD_LIBS =
+    INSPECT_LIBS =
+endif
+
+ifeq (1,$(WITH_THREAD_PROFILING))
+	override EXTRA_FLAGS += -DPER_THREAD_TIMING=1
+endif
+
+ifeq (1,$(WITH_AFFINITY))
+	override EXTRA_FLAGS += -DWITH_AFFINITY=1
+endif
+
+#default is to use Intel TBB's queuing lock for better thread scaling performance
+ifneq (1,$(NO_QUEUELOCK))
+	override EXTRA_FLAGS += -DNO_SPINLOCK
+	override EXTRA_FLAGS += -DWITH_QUEUELOCK=1
+endif
+
+ifeq (1,$(WITH_FINE_TIMER))
+	override EXTRA_FLAGS += -DUSE_FINE_TIMER=1
 endif
 
 OTHER_CPPS = ccnt_lut.cpp ref_read.cpp alphabet.cpp shmem.cpp \
              edit.cpp ebwt.cpp
-ifneq (1,$(WITH_TBB))
+
+ifeq (1,$(WITH_COHORTLOCK))
+	override EXTRA_FLAGS += -DWITH_COHORTLOCK=1
+	OTHER_CPPS += cohort.cpp cpu_numa_info.cpp
+endif
+
+ifeq (1,$(NO_TBB))
 	OTHER_CPPS += tinythread.cpp
 endif
 
@@ -332,7 +364,7 @@
 		$(OTHER_CPPS) \
 		$(LIBS)
 
-bowtie-inspect-s-debug: bowtie_inspect.cpp $(HEADERS) $(OTHER_CPPS) 
+bowtie-inspect-s-debug: bowtie_inspect.cpp $(HEADERS) $(OTHER_CPPS)
 	$(CXX) $(DEBUG_FLAGS) \
 		$(DEBUG_DEFS) $(ALL_FLAGS) \
 		$(DEFS) -Wall \
@@ -341,7 +373,7 @@
 		$(OTHER_CPPS) \
 		$(LIBS)
 
-bowtie-inspect-l-debug: bowtie_inspect.cpp $(HEADERS) $(OTHER_CPPS) 
+bowtie-inspect-l-debug: bowtie_inspect.cpp $(HEADERS) $(OTHER_CPPS)
 	$(CXX) $(DEBUG_FLAGS) \
 		$(DEBUG_DEFS) $(ALL_FLAGS) \
 		$(DEFS) -DBOWTIE_64BIT_INDEX -Wall \
@@ -357,24 +389,25 @@
 	zip -r tmp.zip $(SRC_PKG_LIST)
 	mv tmp.zip .src.tmp/bowtie-$(VERSION)
 	cd .src.tmp/bowtie-$(VERSION) ; unzip tmp.zip ; rm -f tmp.zip
-	cd .src.tmp ; zip -r $@ bowtie-$(VERSION)
-	cp .src.tmp/$@ .
+	cd .src.tmp ; zip -r $@.zip bowtie-$(VERSION)
+	cp .src.tmp/$@.zip .
 	rm -rf .src.tmp
 
-bowtie-bin.zip: $(BIN_PKG_LIST) $(BIN_LIST) $(BIN_LIST_AUX) 
+bowtie-bin.zip: $(BIN_PKG_LIST) $(BIN_LIST) $(BIN_LIST_AUX)
+	$(eval HAS_TBB=$(shell strings bowtie-align-l* | grep tbb))
+	$(eval PKG_DIR=bowtie-$(VERSION)$(if $(HAS_TBB),,-legacy))
 	chmod a+x scripts/*.sh scripts/*.pl
 	rm -rf .bin.tmp
-	mkdir .bin.tmp
-	mkdir .bin.tmp/bowtie-$(VERSION)
+	mkdir -p .bin.tmp/$(PKG_DIR)
 	if [ -f bowtie-align-s.exe ] ; then \
 		zip tmp.zip $(BIN_PKG_LIST) $(addsuffix .exe,$(BIN_LIST) $(BIN_LIST_AUX)) ; \
 	else \
 		zip tmp.zip $(BIN_PKG_LIST) $(BIN_LIST) $(BIN_LIST_AUX) ; \
 	fi
-	mv tmp.zip .bin.tmp/bowtie-$(VERSION)
-	cd .bin.tmp/bowtie-$(VERSION) ; unzip tmp.zip ; rm -f tmp.zip
-	cd .bin.tmp ; zip -r $@ bowtie-$(VERSION)
-	cp .bin.tmp/$@ .
+	mv tmp.zip .bin.tmp/$(PKG_DIR)
+	cd .bin.tmp/$(PKG_DIR) ; unzip tmp.zip ; rm -f tmp.zip
+	cd .bin.tmp ; zip -r $(PKG_DIR).zip $(PKG_DIR)
+	cp .bin.tmp/$(PKG_DIR).zip .
 	rm -rf .bin.tmp
 
 .PHONY: doc
@@ -397,11 +430,28 @@
 		cp -f $$file $(DESTDIR)$(bindir) ; \
 	done
 
+.PHONY: simple-test
+simple-test: all perl-deps
+	eval `perl -I $(CURDIR)/.perllib.tmp/lib/perl5 -Mlocal::lib=$(CURDIR)/.perllib.tmp` ; \
+	./scripts/test/simple_tests.pl --bowtie=./bowtie --bowtie-build=./bowtie-build
+
+.PHONY: random-test
+random-test: all perl-deps
+	eval `perl -I $(CURDIR)/.perllib.tmp/lib/perl5 -Mlocal::lib=$(CURDIR)/.perllib.tmp` ; \
+	./scripts/test/random_bowtie_tests.sh
+
+.PHONY: perl-deps
+perl-deps:
+	if [ ! -e .perllib.tmp ]; then \
+		DL=$$([ `which wget` ] && echo wget -O- || echo curl -L) ; \
+		mkdir .perllib.tmp ; \
+		$$DL http://cpanmin.us | perl - -l $(CURDIR)/.perllib.tmp App::cpanminus local::lib ; \
+		eval `perl -I $(CURDIR)/.perllib.tmp/lib/perl5 -Mlocal::lib=$(CURDIR)/.perllib.tmp` ; \
+		cpanm Math::Random Clone Test::Deep ; \
+	fi
 
 .PHONY: clean
 clean:
 	rm -f $(BIN_LIST) $(BIN_LIST_AUX) \
 	bowtie_prof \
 	$(addsuffix .exe,$(BIN_LIST) $(BIN_LIST_AUX) bowtie_prof) \
-	bowtie-src.zip bowtie-bin.zip
-	rm -f core.*

=== debian/changelog ===
bowtie (1.2.0+dfsg-1) unstable; urgency=medium

  * New upstream version.
    - Threading with tbb
    - queue-based lock rather than spin/heavyweight lock
    - reduced thread synchronization
  * Added 'dfsg' to version because of removed seqan source tree
  * debian/upstream/metadata: Added RRID reference
  * debian/watch: Adjusted for new distribution via github
  * Team upload provided by new aspiring Debian Med member,
    sponsored by <moeller>

 -- Stephan Struckmann <stephan.struckmann@gmail.com>  Thu, 08 Jun 2017 15:24:17 +0200

bowtie (1.1.2-6) unstable; urgency=medium

  * Enable build on all 64bit architectures (thanks for the patch to James
    Cowgill <jcowgill@debian.org>)
    Closes: #840775

 -- Andreas Tille <tille@debian.org>  Fri, 14 Oct 2016 20:53:17 +0200

bowtie (1.1.2-5) unstable; urgency=medium

  * Team upload.
  * Make build reproducible again.
    - Remove build directory from recorded CFLAGS.

 -- Sascha Steinbiss <satta@debian.org>  Wed, 07 Sep 2016 10:13:36 +0000

bowtie (1.1.2-4) unstable; urgency=medium

  * Team upload.
  * Make build reproducible.
    - Use fixed build hostname and compiler version.
  * Fix autopkgtest by adjusting directory.
  * Enable full hardening.
  * Bump Standards-Version.
  * Use secure Vcs-Browser.

 -- Sascha Steinbiss <sascha@steinbiss.name>  Wed, 25 May 2016 22:25:27 +0000

=== debian/control ===
--- 
+++ 
@@ -2,20 +2,22 @@
 Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
 Uploaders: Steffen Moeller <moeller@debian.org>,
            Andreas Tille <tille@debian.org>,
-           Ognyan Kulev <ogi@debian.org>
+           Ognyan Kulev <ogi@debian.org>,
+           Stephan Struckmann <stephan.struckmann@gmail.com>
 Section: science
 Priority: optional
 Build-Depends: debhelper (>= 9),
                help2man,
-               seqan-dev (>= 1.4),
-               python
-Standards-Version: 3.9.6
-Vcs-Browser: http://anonscm.debian.org/viewvc/debian-med/trunk/packages/bowtie/trunk/
+               libtbb-dev,
+               python,
+               seqan-dev (>= 1.4)
+Standards-Version: 3.9.8
+Vcs-Browser: https://anonscm.debian.org/viewvc/debian-med/trunk/packages/bowtie/trunk/
 Vcs-Svn: svn://anonscm.debian.org/debian-med/trunk/packages/bowtie/trunk/
 Homepage: http://bowtie-bio.sourceforge.net/
 
 Package: bowtie
-Architecture: amd64 kfreebsd-amd64 arm64 ppc64el
+Architecture: alpha any-amd64 arm64 mips64el ppc64 ppc64el s390x sparc64
 Depends: ${shlibs:Depends},
          ${misc:Depends},
          python

=== debian/watch ===
version=4
# only active up to version 1.1.x
#http://sf.net/bowtie-bio/bowtie-([\d\.]+)-src\.zip
# since 1.2.0
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%bowtie-$1.tar.gz%" \
   https://github.com/BenLangmead/bowtie/tags \
   (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate

## bowtie 1.2.2%2Bdfsg

=== debian/rules ===
--- 
+++ 
@@ -6,9 +6,9 @@
 # Uncomment this to turn on verbose mode.
 #export DH_VERBOSE=1
 
-# export DEB_BUILD_MAINT_OPTIONS = hardening=+all
+export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 
-pkg := $(shell dpkg-parsechangelog | sed -n 's/^Source: //p')
+pkg := bowtie
 
 %:
 	dh $@
@@ -19,6 +19,7 @@
 override_dh_auto_install-arch:
 	# remove strange byte-compyled Python code bowtie-buildc (no idea how and why it was created)
 	find . -name bowtie-buildc -delete
+	find . -name .cvsignore -delete
 
 override_dh_installman-arch:
 	help2man --name="ultrafast memory-efficient short read aligner" --no-info \
@@ -46,6 +47,3 @@
 	ln -s debian/tests
 	sh debian/tests/run-unit-test test_at_build_time
 	rm -f tests examples[0-9].out
-
-get-orig-source:
-	uscan --verbose --force-download --repack --compress xz
